%{!?python_sitearch: %define python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}

Name: picviz
Version: 0.6
Release: 3%{?dist}
Summary: Parallel coordinates plotter

License: GPLv3+
Group: Applications/Engineering
URL: http://www.wallinfire.net/picviz
Source0: http://www.wallinfire.net/files/picviz/libpicviz-%{version}.tar.gz
Source1: http://www.wallinfire.net/files/picviz/picviz-cli-%{version}.tar.gz
Source2: http://www.wallinfire.net/files/picviz/picviz-gui-%{version}.tar.gz
#Source3: http://www.wallinfire.net/files/picviz/picviz-parsers-%{version}.tar.gz
Source4: %{name}.desktop
Patch0: libpicviz-%{version}-libdir.patch
Patch1: libpicviz-%{version}-cmake.patch
Patch2: libpicviz-%{version}-libev.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires: cmake
BuildRequires: bison
BuildRequires: flex
BuildRequires: python-devel
BuildRequires: pkgconfig
BuildRequires: pcre-devel
BuildRequires: libev-devel
Requires: pcre
Requires(post): /sbin/ldconfig
Requires(postun): /sbin/ldconfig

%package devel
Summary: Picviz development files
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
Requires: pkgconfig

%package gui
Summary: Graphical frontend for picviz
Group: Applications/Engineering
BuildRequires: desktop-file-utils
Requires: %{name} = %{version}-%{release}
Requires: PyQt4

%package plugin-pngcairo
Summary: PNG Cairo plugin for picviz
Group: Applications/Engineering
BuildRequires: cairo-devel
Requires: %{name} = %{version}-%{release}
Requires: cairo

%description
Picviz is a parallel coordinates plotter which enables easy scripting
from various input (tcpdump, syslog, iptables logs, apache logs,
etc..) to visualize your data and discover interesting results
quickly.

Its primary goal is to graph data in order to be able to quickly
analyze problems and find correlations among variables. With security
analysis in mind, the program has been designed to be very flexible,
able to graph millions of events.

The language is designed to be close to the graphviz graph description
language.

%description devel
Header files for libpicviz.

%description gui
Graphical frontend for picviz.

%description plugin-pngcairo
Plugin for generating output using cairo-png.

%prep
%setup -q -c -a 1 -a 2
%patch0 -p0 -b .libdir
%patch1 -p0 -b .cmake
%patch2 -p0 -b .libev


%build
# libpicviz
pushd libpicviz-%{version}
mkdir -p build
pushd build
%cmake -DCMAKE_SKIP_RPATH:BOOL=ON ..
make %{?_smp_mflags}
popd

pushd src/bindings/python
python ./setup.py build
popd
popd

# cli
pushd picviz-cli-%{version}
pushd src
gcc -g -I../../libpicviz-%{version}/src/include -o pcv pcv.c \
  -L../../libpicviz-%{version}/build/src -lpicviz -lpcre
popd

mkdir -p build
pushd build
%cmake ../doc
popd
popd

# gui
pushd picviz-gui-%{version}
python ./setup.py build
popd


%install
rm -rf %{buildroot}

# libpicviz
pushd libpicviz-%{version}
make install DESTDIR=%{buildroot}

pushd src/bindings/python
python ./setup.py install --root=%{buildroot} --install-lib=%{python_sitearch}
chmod 755 %{buildroot}/%{python_sitearch}/picviz.so
popd
popd

# cli
pushd picviz-cli-%{version}
mkdir -p %{buildroot}/%{_bindir}
install -p -m 755 src/pcv %{buildroot}/%{_bindir}/pcv
install -d -m 755 %{buildroot}/%{_datadir}/%{name}/templates
install -p -m 644 templates/*.pgdt %{buildroot}/%{_datadir}/%{name}/templates

pushd build
make install DESTDIR=%{buildroot}
popd
popd

# gui
pushd picviz-gui-%{version}
python ./setup.py install --root=%{buildroot} --install-lib=%{python_sitearch}
popd

desktop-file-install --vendor="fedora" --dir=%{buildroot}/%{_datadir}/applications %{SOURCE4}


%clean
rm -rf %{buildroot}

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%doc libpicviz-%{version}/COPYING picviz-cli-%{version}/samples
%{_mandir}/man1/*
%{_datadir}/%{name}/

%{_libdir}/*.so.*
%dir %{_libdir}/libpicviz
%{_libdir}/libpicviz/*.so
%exclude %{_libdir}/libpicviz/libpicvizoutpngcairo.so
%{python_sitearch}/picviz.so
%{python_sitearch}/Picviz*.egg-info
%{_bindir}/pcv

%files devel
%defattr(-,root,root,-)
%{_libdir}/libpicviz.so
%{_libdir}/pkgconfig/libpicviz.pc
%{_includedir}/*

%files gui
%defattr(-,root,root,-)
%dir %{python_sitearch}/PicvizGui
%{python_sitearch}/PicvizGui/*
%{python_sitearch}/picviz_gui*.egg-info
%{_bindir}/picviz-gui
%{_datadir}/applications/fedora-%{name}.desktop

%files plugin-pngcairo
%defattr(-,root,root,-)
%{_libdir}/libpicviz/libpicvizoutpngcairo.so

%changelog
* Wed Jul 21 2010 David Malcolm <dmalcolm@redhat.com> - 0.6-3
- Rebuilt for https://fedoraproject.org/wiki/Features/Python_2.7/MassRebuild

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.6-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu Jul 23 2009 Tomas Heinrich <theinric@redhat.com> 0.6-1
- upgrade to 0.6
  - upstream package has split into libpicviz, picviz-cli, picviz-gui,
    picviz-parsers; pull them in to preserve current functionality,
    but they should later go into their own packages
  - drop plugin-plplot package as it is no longer supported,
    remove BuildRequires: plplot-devel
  - BuildRequires: libev-devel instead of libevent-devel
  - several file paths changed

* Wed Mar 18 2009 Tomas Heinrich <theinric@redhat.com> 0.5-1
- upgrade

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.4-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Sat Nov 29 2008 Ignacio Vazquez-Abrams <ivazqueznet+rpm@gmail.com> - 0.4-2
- Rebuild for Python 2.6

* Mon Oct 27 2008 Tomas Heinrich <theinric@redhat.com> 0.4-1
- update to new upstream version

* Mon Sep 22 2008 Tomas Heinrich <theinric@redhat.com> 0.2.3-2
- fix plugin path (#462700)

* Thu Aug  7 2008 Tomas Heinrich <theinric@redhat.com> 0.2.3-1
- Initial build
